; ASPI v. 9-13
; Sada skript a konfiguranch soubor k aplikaci ASPI v. 9-13 (star verze rozhran aplikace; aplikan soubor ASPIWIN13.EXE),
; verze 2.1, 4. 3. 2019
; odladno pro barevnou hloubku grafickho rozlien 32 a 16 bit
; odladno pro JAWS 7.10 a Windows XP a vy
; sestavil Svatoslav Ondra
; (c) Masarykova univerzita 2007-2019


Include "HjConst.jsh"

Const
	CurrentOcurrenceBackground = 255,														; slo barvy pozad aktulnho vskytu hledanho etzce
	GreenRegulationStatus1 = 8566910,															; slo barvy pozad pedpisu vyznaenho zelen (32 bit)
	RedRegulationStatus1 = 4474111,																; slo barvy pozad pedpisu vyznaenho ervn (32 bit)
	BlueRegulationStatus1 = 10485760,															; slo barvy pozad pedpisu vyznaenho mode (32 bit)
	GreenRegulationStatus2 = 8437888,															; slo barvy pozad pedpisu vyznaenho zelen (16 bit)
	RedRegulationStatus2 = 4210943,																; slo barvy pozad pedpisu vyznaenho ervn (16 bit)
	BlueRegulationStatus2 = 12582912,															; slo barvy pozad pedpisu vyznaenho mode (16 bit)
	FindTextWindowClassName = "AfxFrameOrView70",						; jmno tdy okna s textem pedpisu
	RegulationListWindowClass = "SysListView32",									; jmno tdy okna se seznamem vsledk hledn v pedpisech
	RegulationListWindowID = 1112,																; ID okna se seznamem vsledk hledn v pedpisech
	NotPassingThroughScriptShortcut = "JAWSKey+C",						; klvesov zkratka pro vyvoln funkce bez proputn F3 / Shift+F3
	ListOfFilterFormItems = "Tlatko Cel seznam|innost|Druh|Autor|Filtr vztah|Zdroj|Psobnost|Oznaen",
																																		; seznam formulovch pol pro stanoven filtru vpisu vyhledanch pedpis
	GoToFilterFormItemsWindowTitle = "Kritria zobrazench pedpis",	; titulek pomocnho naviganho okna JAWS se seznamem formulovch pol pro stanoven filtru vpisu vyhledanch pedpis
	NoOcurrenceFoundMsg = "Hledan vraz nenalezen.",					; chybov hlen pi nenalezen zvraznnho vrazu
	FilterFormItemDisabledOrNotFoundMsg = "Vybran prvek nen dostupn nebo se v okn vbec nenachz.",
																																		; chybov hlen pi nenalezen (nebo nedostupnosti) vybranho pole pro stanoven filtru vpisu vyhledanch pedpis
	FilterFormNotDisplayedInWindowMsg = "Stanoven kritri zobrazench pedpis zde nen mon.",
																																		; chybov hlen, kdy formul pro stanoven filtru vpisu vyhledanch pedpis se v aktulnm okn nenachz
	RegulationCancelledMsg = "Zruen",														; text stavu pedpisu, kter se nachz v seznamu vyhledanch pedpis, - zruen
	RegulationValidButNotEffectiveMsg = "Platn, neinn",			; text stavu pedpisu, kter se nachz v seznamu vyhledanch pedpis, - platn, neinn
	RegulationNormalMsg = ""																			; text stavu pedpisu, kter se nachz v seznamu vyhledanch pedpis, - platn, inn


Script ASPIFindNext ()

	If GetCurrentScriptKeyName() != NotPassingThroughScriptShortcut then	; Klvesu F3 / Shift+F3 propustit do ASPI jen tehdy, kdy je skript vyvoln prv j,...
		TypeCurrentScriptKey ()
	Endif
	Delay (2)
	If GetWindowClass(GetFocus()) == FindTextWindowClassName  then	; ...ale doprovodn operace provdt, jen kdy se kurzor nachz v okn s textem pedpisu.
		JAWSCursor ()
		SaveCursor ()																									; Uchov aktuln pozici JAWS kurzoru.
		; RouteJAWSToPC ()																						; ve verzi 2.1 odstranno, zpsobovalo obasn nenalezen aktulnho vskytu
		SetRestriction (RestrictWindow)
		If FindColors (IgnoreColor, CurrentOcurrenceBackground, S_Top) then
			RoutePCToJAWS ()
			RestoreCursor ()																							; Po splnn kolu se JAWS kurzor vrac na pvodn msto.
			PCCursor ()																										; Po vykonn operac bude aktivn vdy PC kurzor.
			Delay (2)
			SayWord ()
		else
			RestoreCursor ()																							; Akoliv vskyt nebyl nalezen, mus se vynulovat pam uchovanch pozic kurzoru.
			PCCursor ()																										; Aby byl typ aktivnho kurzoru po vykonn operace vdy stejn, pro jistotu se nastavuje PC kurzor, i kdy nebyl vskyt nalezen.
			Say (NoOcurrenceFoundMsg, ot_jaws_message)
		Endif
	Endif

EndScript


int Function IsRegulationList ()																		; pomocn funkce - testuje, zda se kurzor nachz v seznamu vyhledanch pedpis (nefunguje stoprocentn, je pravda i v jinch seznamech)

	If (GetWindowClass(GetFocus()) == RegulationListWindowClass) && (GetControlID(GetFocus()) == RegulationListWindowID) && (not DialogActive ()) && (not MenusActive ()) then 
		Return true
	Else
		Return false
	EndIf

EndFunction


string Function GetRegulationStatusString ()											; pomocn funkce - zjiuje stav pedpisu v seznamu vyhledanch pedpis podle barvy pozad

	var int ColorBackground,
			string Result

	SaveCursor ()
	JAWSCursor ()
	SaveCursor ()
	RouteJAWSToPC ()
	Let ColorBackground = GetColorBackground ()
	If (ColorBackground == RedRegulationStatus1) || (ColorBackground == RedRegulationStatus2) then Let Result = RegulationCancelledMsg EndIf
	If (ColorBackground == GreenRegulationStatus1) || (ColorBackground == GreenRegulationStatus2) then Let Result = RegulationValidButNotEffectiveMsg EndIf
	If (ColorBackground == BlueRegulationStatus1) || (ColorBackground == BlueRegulationStatus2) then Let Result = RegulationNormalMsg EndIf
	RestoreCursor ()
	RestoreCursor ()
	Return Result

EndFunction								


void Function ActiveItemChangedEvent (handle curHwnd, int curObjectId, int curChildId, handle prevHwnd, int prevObjectId, int prevChildId)
																																		; po kad zmn aktivnho prvku v objektu dojde k vyvoln funkce ActiveItemChangedEvent - pokud je kurzor v seznamu vyhledanch pedpis, ohls stav aktulnho pedpisu

	If IsPCCursor () && IsRegulationList () then
		Say (GetRegulationStatusString (), ot_no_disable)
	EndIf
	ActiveItemChangedEvent (curHwnd, curObjectId, curChildId, prevHwnd, prevObjectId, prevChildId)

EndFunction


Script SayLine ()																										; pi vyvoln funkce ten dku se na ni, pokud je kurzor v seznamu vyhledanch pedpis, nave ohlen stavu aktulnho pedpisu

	If IsPCCursor () && IsRegulationList () then
		Say (GetRegulationStatusString (), ot_no_disable)
	EndIf
	PerformScript SayLine ()

EndScript


Script GoToFilterFormItem ()

	var int SelItemIndex, int SelItemID, int OrigScreenEcho,
			string SelItemClass, string SelItemClassShouldBe,
			handle SelItemHandle

	Let OrigScreenEcho = GetScreenEcho ()
	If OrigScreenEcho == echo_all then																; touto oklikou nastavuji odezvy obrazovky na dnou
		ScreenEcho ()
	ElIf OrigScreenEcho == echo_highlighted then
		ScreenEcho ()
		ScreenEcho ()
	EndIf
	If IsRegulationList () then
		Let SelItemIndex = DlgSelectItemInList (ListOfFilterFormItems, GoToFilterFormItemsWindowTitle, False)
		Delay (2)
		If SelItemIndex != 0 then
			Let SelItemID = 1423 + SelItemIndex													; Protoe ID jednotlivch pol jdou v poad 1424, 1425, 1426...
			JAWSCursor ()
			Let SelItemHandle = FindDescendantWindow (GetAppMainWindow(GetFocus()), SelItemID)
			Let SelItemClass = GetWindowClass (SelItemHandle)
			If SelItemID == 1424 then																			; vechno jsou comboboxy, jen prvn prvek (id 1424) je button
				Let SelItemClassShouldBe = "Button"
			Else
				Let SelItemClassShouldBe = "ComboBox"
			EndIf
			If IsWindowVisible (SelItemHandle) && not (IsWindowDisabled (SelItemHandle)) && (SelItemClass == SelItemClassShouldBe) && MoveToWindow (SelItemHandle) then
				RoutePCToJAWS ()
			Else
				Say (FilterFormItemDisabledOrNotFoundMsg, ot_jaws_message)
			EndIf
			PCCursor ()
		EndIf
	Else
		Say (FilterFormNotDisplayedInWindowMsg, ot_jaws_message)
	EndIf
	If OrigScreenEcho == echo_highlighted then											; touto oklikou nastavuji pvodn hodnotu odezvy obrazovky
		ScreenEcho ()																										; pvodn hodnota je urit echo_none, proto volm jen jednou
	ElIf OrigScreenEcho == echo_all then
		ScreenEcho ()																										; pvodn hodnota je urit echo_none, proto volm dvakrt
		ScreenEcho ()
	EndIf

EndScript


Script GetBackgroundColorNumber ()															; pracovn skript pro zjitn sla barvy pozad na pozici PC kurzoru

	JAWSCursor ()
	RouteJAWSToPC ()
	SayString (IntToString(GetColorBackground()))
	PCCursor ()

EndScript